commit:     5d02cee98891f81ffbc280b313c7d79e9f343f89
Author:     Benda Xu <heroxbd <AT> gentoo <DOT> org>
AuthorDate: Tue Dec 16 05:13:44 2014 +0000
Commit:     Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Tue Dec 16 05:13:44 2014 +0000
URL:        
http://sources.gentoo.org/gitweb/?p=dev/heroxbd.git;a=commit;h=5d02cee9

sys-devel/binutils-config: bump to 4

---
 sys-devel/binutils-config/ChangeLog                |  13 +-
 sys-devel/binutils-config/Manifest                 |   8 +-
 .../binutils-config/binutils-config-3-r3.ebuild    |  15 +-
 sys-devel/binutils-config/binutils-config-4.ebuild |  24 ++
 .../binutils-config/files/binutils-config-1.9      |   0
 sys-devel/binutils-config/files/binutils-config-2  |   0
 sys-devel/binutils-config/files/binutils-config-4  | 471 +++++++++++++++++++++
 sys-devel/binutils-config/files/binutils-config.8  |  25 --
 .../patches/binutils-config-prefix.patch           | 209 ---------
 sys-devel/binutils-config/patches/series           |   1 -
 10 files changed, 515 insertions(+), 251 deletions(-)

diff --git a/sys-devel/binutils-config/ChangeLog 
b/sys-devel/binutils-config/ChangeLog
index 6d6b518..8fb2d57 100644
--- a/sys-devel/binutils-config/ChangeLog
+++ b/sys-devel/binutils-config/ChangeLog
@@ -1,6 +1,15 @@
 # ChangeLog for sys-devel/binutils-config
-# Copyright 1999-2013 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/sys-devel/binutils-config/ChangeLog,v 1.64 
2013/05/05 05:20:42 vapier Exp $
+# Copyright 1999-2014 Gentoo Foundation; Distributed under the GPL v2
+# $Header: /var/cvsroot/gentoo-x86/sys-devel/binutils-config/ChangeLog,v 1.66 
2014/07/29 11:15:38 vapier Exp $
+
+*binutils-config-4 (29 Jul 2014)
+
+  29 Jul 2014; Mike Frysinger <[email protected]> +binutils-config-4.ebuild,
+  +files/binutils-config-4, files/binutils-config.8:
+  Drop FAKE_TARGETS support as gcc dropped it a while ago too #467488.
+
+  18 Jan 2014; Mike Frysinger <[email protected]> binutils-config-3-r3.ebuild:
+  Add arm64 love.
 
   05 May 2013; Mike Frysinger <[email protected]> files/binutils-config-3:
   Also try to rmdir target bin/libexec paths when uninstalling.

diff --git a/sys-devel/binutils-config/Manifest 
b/sys-devel/binutils-config/Manifest
index f3a3cd0..1c31866 100644
--- a/sys-devel/binutils-config/Manifest
+++ b/sys-devel/binutils-config/Manifest
@@ -1,9 +1,11 @@
 AUX binutils-config-1.9 11043 SHA256 
20becd27cd1161d3afcd079ebff883b8eba3e698171937d82a9575dfa19a2373 SHA512 
d0366bd547d7c2adddf30975a361b2f25d008f0203db9e53cd81e635fd081e0ce13940a1df511f6edc7a11d6c4e641567cb750006cbbaa7b5bfd118bf6f87464
 WHIRLPOOL 
d2c06206ffb351226db6db89e305042c03cf3cfa628c440fd3fd7274bf0c62c8ba61599f4997714075dc9f61b57a46709824eded2a31678bc2668e43c982ce91
 AUX binutils-config-2 11440 SHA256 
5e923d1445910b9b9d1e455e52313087098689359846db0dc3fa52d33b63b192 SHA512 
16b8bc2277bb50fb803377b192368a7abf7c97b5959bdd0d67fcf508220164d29ee2cfc1526ecfce7125b7492a0a5e4f094e948fa5ba9af44487229af3d91197
 WHIRLPOOL 
3acedb96e6c0c97e2223aa5fffcfb59f7e7b311c883e1557191db14b166a01d14ecd6eafbd4a4dbd33ceb2ca388fa7bf54d8291a24bb5e26a5634e2c8fb2a2df
 AUX binutils-config-3 13874 SHA256 
d4395a6480a179165098433235726f416aea4029474ecf93534c4ec844422788 SHA512 
8c486629109fd67bebc248a629d38bc2ad0546c70fe42e82ccb609932ec2cdbe32545486f437bb15c81318ad7d9f962fdd63fe1156ea844c31ba2812362a792c
 WHIRLPOOL 
8555808ff549955ba93b9331ccf5424056817339745309b6f5b3064f594f22ae44eeab0cd3b9724b67fe1860cfb5048b8c95792075b6b4423659a75ef6633783
-AUX binutils-config.8 4113 SHA256 
ec7cb82331c80e15581e0936a5bf5edb3cde78bec3c3ede647926821086a1e6f SHA512 
608e32ca64a82e0975cb247d30914db25668f637e30fd486f7322566065cc420470d237415da53ba7eb12daf4389b049b5ec8b2f8af598bf03803f48fd77f933
 WHIRLPOOL 
d1ec82404f639718c51a1f983c1d60212ee6e943c6225c16bf4a2a24a8e7aa22093cce0fefa0f331ae7480b7b03ef10931d516e7ecf0a051415565eb583145a0
+AUX binutils-config-4 12111 SHA256 
1d6cf0d1e26e928c5a8c77f98fd8414b21b7b407fcce8621fb10c90820676b1d SHA512 
a3d91417e46bd17b911e205469d665632c5ab7f222f3759736302fd72734ef350973412f1f4876abe796248818594037f8a17c3d5fa1f8f30afb974bc7d7bd39
 WHIRLPOOL 
f5f8345e3a4bae9f5f92f9dfa1decbdd9ff15efcae923a41bfc6f2a0f09767a3b229351c6509175a2bbecedc26e8e26f3f4f70028e03096e5c8b0941629d436b
+AUX binutils-config.8 2837 SHA256 
20817cd2e6e3a8ace12ada7b73ada556d597527adcad02876e522e0b6396d4a3 SHA512 
66a260499c1100dc71469e4ca1e2b0f71410382138c381e6a6ed4e4aa19520607407ffa6a28e0388e0abe5ee86769b662cec29cdb2ff02cc6c05af64314db5d9
 WHIRLPOOL 
8bbc5c525b1c7a3ec147458569d570a3312034da2c75c1f31c4cd888db5205aa0a8c8ec061b2354d8ac80b43bdbdf1559a92e904dae5f681345fe758794c2535
 EBUILD binutils-config-1.9-r4.ebuild 626 SHA256 
4445f3282acda5b7c96146974adefc47315c437b5eb008daab9ac5f87a18d99d SHA512 
82089adb1b63b386280f512a096836189bcd42995f7058cb211c7b01860788be24a4112c3345dd4042ed7b2311bc7b5a40248e55ad2e958519d6b8fd7e341d5e
 WHIRLPOOL 
b4409b6e396e42bf0dea54a1cc8aa912d7f1f215d7143d955ead38b1dea883d95b0b518fe198df72f21af8a954b148b7d18d292d6965a82417856fffccaa0ac7
 EBUILD binutils-config-2-r1.ebuild 627 SHA256 
06d97c5306e671ccf55fcad8eec8dcd20e1c6c3bb8e4646771d62af5f1e1754f SHA512 
856c552643f31f3df0218442c0290f7cb090c5088e0796ad03e5e07f5bdf0f8d3233b1659556e5768909a557971e5e5ebc702ba4a39658c7a862c4d5336364e6
 WHIRLPOOL 
e5af63fd41361217f60dcfa84a605616a7bb0037fb986f00f3f866dff19bfa3fb96365b10be4854b6a27d643ccb2d682910644df5941e7f4d88f341ae2e6ad3c
-EBUILD binutils-config-3-r3.ebuild 707 SHA256 
8968f1bffb5833a1c07218cd58a22d916b3893595bc9a3fb35c7cde5e3723430 SHA512 
5c186730e338c9e323d791d18a620c25b9c4bddf33bf022b49aad41ee0f21a260ef8faa195e93ece8b8073b74676e78d88a7dfd5d2df9cc19afabddf0e699625
 WHIRLPOOL 
859523cfdd14f969490b5612a59dfe6f4310b41d892dc0358aa55ed9c3c862ef70ac660192b1f85a1d2b39100b59ab73995d2ffd675a81c1268327aeb759c74f
-MISC ChangeLog 10639 SHA256 
a8af81fa54be4a7b190f0bcda2dd76e4f0fa8a7ce378137905c6651e14812789 SHA512 
5459aef57257c30e1d11d1fdbda8250212d8ed279eae39a05af0608e182dca1711587c0e9b1278300ac68124528fc76b4554d3b71c1c99d9ce623e275d89faf5
 WHIRLPOOL 
2789b5b110eb6332e0fc4f006c1aadd4763fd34b6deea857e9d6f399fbbbb18b1ec8819d2d7d10dd05e1565b2b42ddb32746ab8787679f6d2727676d766f0350
+EBUILD binutils-config-3-r3.ebuild 645 SHA256 
f06ca4397099677760eca41ef1ea3fc4cc3f55d755ff1cd51d607e60bf850af9 SHA512 
73a592d324d7d537c3d67ad7402f13fe2b165fc241db373dd982015ada8b92d0bf961dd01e705cd3e77f704811535053f7a360fa24437bf25f5305f3f9713702
 WHIRLPOOL 
75f57d9150498c247589500945f09b07f83d12e86e4f7c213f86ffa6c8af51b28c60e18ea85b51cc02fd9fa1c30bd969c366aba2d81c7690d2a09be0eac8d413
+EBUILD binutils-config-4.ebuild 694 SHA256 
c3d1239293d5b9202bca8ad676589f8fc4765b2f2f020a444013d802205efb5c SHA512 
642fc5e12d4f2ff18d9344e43ab8a921230374df8e3c532e01368753053d084ef95fc93bfe5c6dbfdfce6ef8eeed86e3cdcece287ccf4330b0f74581537f2a47
 WHIRLPOOL 
342d7c82e29142a42bacc90a5a70167b17b339a1957ecd441b866227249009959f0bcdf66ac1fff38b3f0e450e7fc322fe787ecedfb95a2717215785b08a3b63
+MISC ChangeLog 10973 SHA256 
ccd4960beebcbc858597c6a2fcc518804f496c580dcd60614f8eadc21237defc SHA512 
d0ca8953ac9b086e22d658d7c81657461f31d30da13cf9125819fe0f937ad185d8667e8b55d68c82ec71a00c70bc18683cfbc5df40b8118af6beb27ce977329e
 WHIRLPOOL 
512320d1ded539d35cbd8b2a1240bdd871841c1727a9de91b6aa7e0b8f498da19c572816ad1211546a5818b8ecb1ee32f2037964ade786e2cc970184c86e26b9
 MISC metadata.xml 162 SHA256 
65a915d44de1f01d4b7f72d313b4192c38374a9835d24988c00c1e73dca5805a SHA512 
2a857e10b277827773a6c7967e070d7bfff23d75f44fa4d4fa8a7339df3225e6dba512a865d91c9c55bdb013dafdce85dface1b845acfbb5473e232666cdda45
 WHIRLPOOL 
f7586c1570803b3e646f0be89ba6c767e82ec6889ef92d15f62a38f1410ed9d82c36892e5e83f694471959783d0d5ad667f1a39b7eb51f2080c269d5fa23d819

diff --git a/sys-devel/binutils-config/binutils-config-3-r3.ebuild 
b/sys-devel/binutils-config/binutils-config-3-r3.ebuild
index 5ceaf2d..7c73deb 100644
--- a/sys-devel/binutils-config/binutils-config-3-r3.ebuild
+++ b/sys-devel/binutils-config/binutils-config-3-r3.ebuild
@@ -1,6 +1,6 @@
-# Copyright 1999-2012 Gentoo Foundation
+# Copyright 1999-2014 Gentoo Foundation
 # Distributed under the terms of the GNU General Public License v2
-# $Header: 
/var/cvsroot/gentoo-x86/sys-devel/binutils-config/binutils-config-3-r3.ebuild,v 
1.9 2012/07/29 18:36:13 armin76 Exp $
+# $Header: 
/var/cvsroot/gentoo-x86/sys-devel/binutils-config/binutils-config-3-r3.ebuild,v 
1.10 2014/01/18 03:08:02 vapier Exp $
 
 DESCRIPTION="Utility to change the binutils version being used"
 HOMEPAGE="http://www.gentoo.org/";
@@ -8,19 +8,12 @@ SRC_URI=""
 
 LICENSE="GPL-2"
 SLOT="0"
-KEYWORDS="alpha amd64 arm hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc x86 
~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+KEYWORDS="alpha amd64 arm arm64 hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc 
x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
 IUSE=""
 
 RDEPEND="userland_GNU? ( !<sys-apps/findutils-4.2 )"
 
-inherit prefix
-
-src_unpack() {
-       cp "${FILESDIR}"/${P} ${PN} || die
-       eprefixify ${PN} || die
-}
-
 src_install() {
-       dobin ${PN} || die
+       newbin "${FILESDIR}"/${PN}-${PV} ${PN} || die
        doman "${FILESDIR}"/${PN}.8
 }

diff --git a/sys-devel/binutils-config/binutils-config-4.ebuild 
b/sys-devel/binutils-config/binutils-config-4.ebuild
new file mode 100644
index 0000000..e709158
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-4.ebuild
@@ -0,0 +1,24 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: 
/var/cvsroot/gentoo-x86/sys-devel/binutils-config/binutils-config-4.ebuild,v 
1.1 2014/07/29 11:15:38 vapier Exp $
+
+EAPI="4"
+
+inherit prefix
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/";
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 
~sh ~sparc ~x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+S=${WORKDIR}
+
+src_install() {
+       cp "${FILESDIR}"/${PN}-${PV} "${T}"/
+       eprefixify "${T}"/${PN}-${PV}
+       newbin "${T}"/${PN}-${PV} ${PN}
+       doman "${FILESDIR}"/${PN}.8
+}

diff --git a/sys-devel/binutils-config/files/binutils-config-1.9 
b/sys-devel/binutils-config/files/binutils-config-1.9
old mode 100644
new mode 100755

diff --git a/sys-devel/binutils-config/files/binutils-config-2 
b/sys-devel/binutils-config/files/binutils-config-2
old mode 100644
new mode 100755

diff --git a/sys-devel/binutils-config/files/binutils-config-4 
b/sys-devel/binutils-config/files/binutils-config-4
new file mode 100755
index 0000000..3bf84fe
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config-4
@@ -0,0 +1,471 @@
+#!/bin/bash
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: 
/var/cvsroot/gentoo-x86/sys-devel/binutils-config/files/binutils-config-4,v 1.1 
2014/07/29 11:15:38 vapier Exp $
+
+# Format of /etc/env.d/binutils/:
+#  config-TARGET:      CURRENT=version for TARGET
+#  TARGET-VER:         has a TARGET and VER variable
+
+EPREFIX="@GENTOO_PORTAGE_EPREFIX@"
+if [[ ${EPREFIX} == "@"GENTOO_PORTAGE_EPREFIX"@" ]] ; then
+       EPREFIX=""
+fi
+
+: ${ROOT:=/}
+[[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
+[[ ${ROOT} != /* ]] && ROOT="${PWD%/}/${ROOT}"
+
+EROOT="${ROOT%/}${EPREFIX}/"
+
+cd "${EPREFIX}/"
+
+trap ":" INT QUIT TSTP
+
+argv0=${0##*/}
+source "${EPREFIX}"/etc/init.d/functions.sh || {
+       echo "${argv0}: Could not source ${EPREFIX}/etc/init.d/functions.sh!" 
1>&2
+       exit 1
+}
+esyslog() { :; }
+die() { eerror "${argv0}: $*"; exit 1; }
+umask 022
+
+usage() {
+cat << USAGE_END
+Usage: ${HILITE}binutils-config${NORMAL} ${GOOD}[options]${NORMAL} 
${BRACKET}[binutils profile]${NORMAL}
+
+${HILITE}General Options:${NORMAL}
+  ${GOOD}-c, --get-current-profile${NORMAL}  Print current profile
+  ${GOOD}-l, --list-profiles${NORMAL}        Print a list of available profiles
+  ${GOOD}-u, --uninstall${NORMAL}            Remove all signs of specified 
target
+  ${GOOD}-d, --debug${NORMAL}                Execute with debug output
+
+${HILITE}General Cruft:${NORMAL}
+  ${GOOD}--linker${NORMAL} <linker>          Switch to specified linker (if 
supported)
+
+Profile names are of the form:  ${BRACKET}<CTARGET>-<binutils version>${NORMAL}
+For example:                    
${BRACKET}i686-pc-linux-gnu-2.15.92.0.2${NORMAL}
+
+For more info, please see ${HILITE}binutils-config${NORMAL}(8).
+USAGE_END
+
+       exit ${1:-1}
+}
+
+mv_if_diff() {
+       if cmp -s "$1" "$2" ; then
+               rm -f "$1"
+       else
+               mv -f "$1" "$2"
+       fi
+}
+atomic_ln() {
+       local target=$1 linkdir=$2 linkname=$3 linktmp linkfull
+       linktmp="${linkdir}/.binutils-config.tmp.${linkname}"
+       linkfull="${linkdir}/${linkname}"
+       if [[ -d ${linkfull} ]] ; then
+               # if linking to a dir, we need a little magic to
+               # make it atomic since `mv -T` is not portable
+               rm -rf "${linktmp}"
+               mkdir -p "${linktmp}"
+               ln -sf "${target}" "${linktmp}/${linkname}"
+               mv "${linktmp}/${linkname}" "${linktmp}/../"
+               rmdir "${linktmp}"
+       else
+               # `ln` will expand into unlink();symlink(); which
+               # is not atomic for a small amount of time, but
+               # `mv` is a single rename() call
+               ln -sf "${target}" "${linktmp}"
+               mv "${linktmp}" "${linkfull}"
+       fi
+}
+
+setup_env() {
+       unset TARGET VER LIBPATH
+       source "${ENV_D}/${PROFILE}"
+       if [[ -z ${TARGET} ]] ; then
+               eerror "${PROFILE} is invalid (no \$TARGET defined) :("
+               return 1
+       fi
+       if [[ -z ${VER} ]] ; then
+               eerror "${PROFILE} is invalid (no \$VER defined) :("
+               return 1
+       fi
+
+       #
+       # Generate binary symlinks
+       #
+       BINPATH=""
+       BINPATH_LINKS=""
+       if [[ ${TARGET} != ${HOST} ]] ; then
+               #
+               # Newer paths: /usr/${HOST}/${TARGET}/...
+               # Older paths: /usr/${TARGET}/...
+               #
+               if [[ -d "${EROOT}"/usr/${HOST}/${TARGET}/binutils-bin/${VER} 
]] ; then
+                       
BINPATH="${EPREFIX}"/usr/${HOST}/${TARGET}/binutils-bin/${VER}
+                       BINPATH_LINKS="${EPREFIX}"/usr/libexec/gcc/${TARGET}
+               fi
+       fi
+       if [[ -z ${BINPATH} ]] ; then
+               BINPATH="${EPREFIX}"/usr/${TARGET}/binutils-bin/${VER}
+               BINPATH_LINKS="${EPREFIX}"/usr/${TARGET}/bin
+       fi
+}
+
+switch_profile() {
+       ebegin "Switching to ${PROFILE}"
+
+       setup_env || return 1
+
+       cd "${ROOT}/${BINPATH}" || exit 1
+       mkdir -p "${ROOT}/${BINPATH_LINKS}" "${EROOT}/usr/bin"
+       for x in * ; do
+               atomic_ln "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}" "${x}"
+               atomic_ln "${BINPATH_LINKS}/${x}" "${EROOT}/usr/bin" 
"${TARGET}-${x}"
+               if [[ ${TARGET} == ${HOST} ]] ; then
+                       atomic_ln "${TARGET}-${x}" "${EROOT}/usr/bin" "${x}"
+               fi
+       done
+
+       #
+       # Generate library / ldscripts symlinks
+       #
+       : ${LIBPATH:=${EPREFIX}/usr/lib/binutils/${TARGET}/${VER}}
+       cd "${ROOT}/${LIBPATH}" || exit 1
+       if [[ ${TARGET} == ${HOST} ]] ; then
+               dstlib=${EROOT}/usr/${HOST}/lib
+       else
+               dstlib=${EROOT}/usr/${HOST}/${TARGET}/lib
+       fi
+       # When upgrading, we need to clean up ldscripts and libs
+       mkdir -p "${dstlib}"
+       rm -rf "${ROOT}/${BINPATH_LINKS}"/ldscripts
+       atomic_ln "${LIBPATH}/ldscripts" "${dstlib}" "ldscripts"
+       find -L "${dstlib}" -type l -exec rm -v {} +
+       for x in lib* ; do
+               atomic_ln "${LIBPATH}/${x}" "${dstlib}" "${x}"
+       done
+
+       #
+       # Generate include symlinks
+       #
+       INCPATH=${LIBPATH}/include
+       if [[ -d ${ROOT}/${INCPATH} ]] ; then
+               cd "${ROOT}/${INCPATH}" || exit 1
+               if [[ ${HOST} == ${TARGET} ]] ; then
+                       mkdir -p "${EROOT}/usr/include"
+                       for x in * ; do
+                               atomic_ln "${INCPATH}/${x}" 
"${EROOT}/usr/include" "${x}"
+                       done
+               else
+                       # Clean out old path -- cannot use '-exec {} +' syntax 
here
+                       find . -type f -exec rm -f 
"${EROOT}/usr/${TARGET}/usr/include/{}" \;
+                       rmdir "${EROOT}/usr/${TARGET}/usr/include" >& /dev/null
+                       rmdir "${EROOT}/usr/${TARGET}/usr" >& /dev/null
+                       rmdir "${EROOT}/usr/${TARGET}" >& /dev/null
+               fi
+       fi
+
+       #
+       # Make sure proper paths get updated
+       #
+       if [[ ${TARGET} == ${HOST} ]] ; then
+               DATAPATH="${EPREFIX}"/usr/share/binutils-data/${TARGET}/${VER}
+               local e="${EROOT}"/etc/env.d/05binutils
+               local ee="${e}.tmp"
+               rm -f "${ee}"
+               [[ -d ${DATAPATH}/man  ]] && echo "MANPATH=${DATAPATH}/man"   
>> "${ee}"
+               [[ -d ${DATAPATH}/info ]] && echo "INFOPATH=${DATAPATH}/info" 
>> "${ee}"
+               # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
+               if [[ -d ${EROOT}/etc/ld.so.conf.d ]] ; then
+                       local l="${EROOT}"/etc/ld.so.conf.d/05binutils.conf
+                       local ll="${l}.tmp"
+                       echo "${EPREFIX}/usr/${TARGET}/lib" > "${ll}"
+                       mv_if_diff "${ll}" "${l}"
+               else
+                       echo "LDPATH=${EPREFIX}/usr/${TARGET}/lib" >> "${ee}"
+               fi
+               mv_if_diff "${ee}" "${e}"
+       fi
+
+       local c="${ENV_D}/config-${TARGET}"
+       local cc="${c}.tmp"
+       echo "CURRENT=${VER}" > "${cc}"
+       mv_if_diff "${cc}" "${c}"
+
+       eend 0
+
+       #
+       # Regen env.d if need/can be
+       #
+       if [[ ${ROOT} == "/" ]] && [[ ${TARGET} == ${HOST} ]] ; then
+               env-update
+               echo
+               ewarn "Please remember to run:"
+               echo
+               ewarn "  # . ${EPREFIX}/etc/profile"
+               echo
+       fi
+
+       return 0
+}
+
+uninstall_target() {
+       : ${TARGET:=${UARG}}
+
+       if [[ ${TARGET} == ${HOST} ]] ; then
+               die "refusing to uninstall native binutils"
+       fi
+
+       shopt -s nullglob
+       PROFILE=""
+
+       for PROFILE in "${ENV_D}"/${TARGET}-* ; do
+               ewarn "Removing all signs of ${PROFILE##*/}"
+               rm -f "${ENV_D}"/${PROFILE}
+       done
+       if [[ -z ${PROFILE} ]] && [[ ! -e ${ENV_D}/config-${TARGET} ]] ; then
+               die "no profiles exist for '${TARGET}'"
+       fi
+
+       rm -f "${ENV_D}"/config-${TARGET} 
"${EROOT}"/etc/ld.so.conf.d/05binutils.conf
+
+       local x
+       for x in \
+               addr2line ar as c++filt elf2flt elfedit flthdr gprof \
+               ld ld.{bfd,gold,real} \
+               nm objcopy objdump ranlib readelf size strings strip
+       do
+               x=(
+                       "${EROOT}"/usr/bin/${TARGET}-${x}
+                       "${EROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
+                       "${EROOT}"/usr/libexec/gcc/${TARGET}/${x}
+               )
+               rm -f "${x[@]}"
+       done
+       for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
+               rm -f "${EROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
+       done
+       for x in bfd iberty opcodes ; do
+               rm -f 
"${EROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
+       done
+       # Delete broken symlinks
+       local destdir="${EROOT}/usr/${HOST}/${TARGET}"
+       rm -f "${destdir}"/lib/ldscripts
+       find -L "${destdir}"/lib -type l -exec rm {} +
+       rmdir \
+               "${destdir}"/{bin,include,lib,usr} \
+               "${destdir}" \
+               "${EROOT}"/var/db/pkg/cross-${TARGET} \
+               "${EROOT}"/usr/{${HOST}/,}${TARGET}/bin \
+               "${EROOT}"/usr/libexec/gcc/${TARGET} \
+               2>/dev/null
+
+       rm -f "${ENV_D}"/${TARGET}-*
+}
+
+set_current_profile() {
+       if [[ ! -f ${ENV_D}/config-${TARGET} ]] ; then
+               eerror "${argv0}: unable to locate a profile for target: 
${TARGET}"
+               return 1
+       fi
+
+       source "${ENV_D}/config-${TARGET}"
+
+       if [[ -z ${CURRENT} ]] ; then
+               eerror "${argv0}: no binutils profile is active!"
+               return 1
+       fi
+
+       echo "${TARGET}-${CURRENT}"
+
+       return 0
+}
+get_current_profile() { echo "${PROFILE}" ; }
+
+list_profiles() {
+       local x i target
+
+       if [[ ${ROOT} != / ]] ; then
+               echo "Using binutils-config info in ${ROOT}"
+       fi
+
+       set -- "${ENV_D}"/*
+       target=
+       i=1
+
+       for x ; do
+               # skip broken links and config files
+               [[ -f ${x} ]] || continue
+               [[ ${x} == */config-* ]] && continue
+
+               source "${x}"
+               if [[ ${target} != ${TARGET} ]] ; then
+                       [[ -n ${target} ]] && echo
+                       target=${TARGET}
+               fi
+
+               x=${x##*/}
+               if [[ -e ${ENV_D}/config-${TARGET} ]] ; then
+                       source "${ENV_D}/config-${TARGET}"
+                       if [[ ${VER} == ${CURRENT} ]] ; then
+                               [[ ${TARGET} == ${HOST} ]] \
+                                       && x="${x} ${GOOD}*${NORMAL}" \
+                                       || x="${x} ${HILITE}*${NORMAL}"
+                       fi
+               fi
+
+               # We would align the [...] field like so:
+               #printf ' [%*ss] %s\n' ${##} "${i}" "${x}"
+               # but this breaks simple scripting: `binutils -l | awk '{print 
$2}'`
+
+               # Or we could align the target col like so:
+               #printf ' [%s]%*s %s\n' "${i}" $(( ${##} - ${#i} )) "" "${x}"
+               # but i'm not sold that it looks better
+
+               # So keep it simple ... only makes a diff anyways for crazy 
people
+               # like me which have 100+ binutils packages installed ...
+               echo " [$i] ${x}"
+               ((++i))
+       done
+}
+
+switch_linker() {
+       local bpath ld=$1
+
+       case ${ld} in
+       ld.*) ;;
+       *) die "not supported: linker must start with 'ld.'" ;;
+       esac
+
+       setup_env || return 1
+       bpath="${ROOT}/${BINPATH}"
+
+       # does this binutils even support the requested linker ?
+       if [[ ! -e ${bpath}/${ld} ]] ; then
+               die "sorry, but ${PROFILE} doesn't support the ${ld} linker"
+       fi
+
+       # switch it up
+       ebegin "Setting default linker to ${ld} for ${PROFILE}"
+       atomic_ln ${ld} "${bpath}" ld
+       eend $?
+}
+
+set_HOST() {
+       # Set HOST to CHOST if it isn't already set
+       : ${HOST:=${CHOST:-$(portageq envvar CHOST)}}
+}
+
+ENV_D="${EROOT}etc/env.d/binutils"
+
+DEBUG="no"
+NEED_ACTION="yes"
+DOIT="switch_profile"
+PROFILE="current"
+HOST=""
+TARGET=""
+unset UARG
+
+select_action() {
+       if [[ ${NEED_ACTION} != "no" ]] ; then
+               NEED_ACTION="no"
+               DOIT=$1
+       else
+               die "one action at a time!"
+       fi
+}
+
+while [[ $# -gt 0 ]] ; do
+       x=$1
+       shift
+       case ${x} in
+               -c|--get-current-profile)  select_action get_current_profile ;;
+               -l|--list|--list-profiles) select_action list_profiles ;;
+               -u|--uninstall)            select_action uninstall_target ;;
+               --linker)                  select_action "switch_linker $1"; 
shift ;;
+               -d|--debug)                DEBUG="yes" ;;
+               -h|--help)                 usage 0 ;;
+               -V|--version)
+                       unset Header
+                       cvsver="$Header: 
/var/cvsroot/gentoo-x86/sys-devel/binutils-config/files/binutils-config-4,v 1.1 
2014/07/29 11:15:38 vapier Exp $"
+                       cvsver=${cvsver##*binutils-config-}
+                       bver=${cvsver%%,v *}
+                       cvsver=${cvsver#* }
+                       echo "binutils-config-${bver} (r${cvsver%% *})"
+                       exit 0
+                       ;;
+               -*)
+                       die "invalid switch!  Try '--help'."
+                       ;;
+               *)
+                       if [[ ${UARG+set} == "set" ]] ; then
+                               die "only one profile/target at a time please"
+                       fi
+                       NEED_ACTION="maybe"
+                       UARG=${x}
+                       ;;
+       esac
+done
+
+[[ ${NEED_ACTION} == "yes" ]] && usage 1
+[[ ${DEBUG} == "yes" ]] && set -x
+
+# All operations need to know the current HOST to figure out
+# what is a native target and what is a cross target
+set_HOST
+
+# All operations need to know the profile the user wants
+case ${DOIT} in
+switch_profile|switch_linker_*)
+       # decode user's profile choice
+       x=${UARG:-$(TARGET=${HOST} set_current_profile)}
+       PROFILE=""
+       if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
+               # User gave us a # representing the profile
+               i=1
+               for y in "${ENV_D}"/* ; do
+                       [[ ${y/config-} != ${y} ]] && continue
+
+                       if [[ -f ${y} ]] && [[ ${x} -eq ${i} ]] ; then
+                               PROFILE=${y##*/}
+                               break
+                       fi
+                       ((++i))
+               done
+       fi
+
+       if [[ -z ${PROFILE} ]] ; then
+               # User gave us a full HOST-ver
+               x=${x##*/}
+               if [[ -f ${ENV_D}/${x} ]] ; then
+                       # Valid HOST-ver yeah!
+                       PROFILE=${x}
+               else
+                       # Not a valid HOST-ver ...
+                       if [[ ! -f ${ENV_D}/config-${x} ]] ; then
+                               # Maybe they just gave us a ver ...
+                               if [[ -f ${ENV_D}/${HOST}-${x} ]] ; then
+                                       x=${HOST}-${x}
+                               else
+                                       die "could not locate '$x' in 
'${ENV_D}/'!"
+                               fi
+                               PROFILE=${x}
+                       else
+                               # Maybe they just gave us a target ... pick 
active profile
+                               PROFILE=$(TARGET=${x} set_current_profile)
+                       fi
+               fi
+       fi
+       ;;
+*)
+       # lookup current profile as the user gave us a target
+       PROFILE=$(TARGET=${UARG:-${HOST}} set_current_profile) || exit 1
+       ;;
+esac
+
+eval ${DOIT}
+
+# vim:ts=4

diff --git a/sys-devel/binutils-config/files/binutils-config.8 
b/sys-devel/binutils-config/files/binutils-config.8
index 4aaaa71..0d8adb5 100644
--- a/sys-devel/binutils-config/files/binutils-config.8
+++ b/sys-devel/binutils-config/files/binutils-config.8
@@ -56,31 +56,6 @@ not all options supported by the bfd linker are supportd by 
the gold linker.
 \fB\-\-bfd\fR
 Change the default linker for the specified \fIPROFILE\fR to the [older but
 stable] bfd linker.  If unsure, stick to this one.
-.TP
-\fB\-\-amd64\fR
-A nice feature of the amd64/x86 toolchain is that each can produce code for 
-other.  The typical user could care less, but some may want to be able to 
-cross-compile for an amd64 on a x86 system.  This will install the extra 
-symlinks ('x86_64') to facilitate this process.
-.TP
-\fB\-\-arm\fR
-The arm architecture comes in both big and little endian versions.  Typically 
-you only need support for the native target, but sometimes it's helpful to 
-have links for the other endian target.  This will make sure you have both the 
-big endian target ('armeb') and the little endian target ('arm').
-.TP
-\fB\-\-mips\fR
-The mips architecture (like arm) comes in both big and little endian versions. 
 
-Typically you only need support for the native target, but sometimes it's 
-helpful to have links for the other endian target.  This will make sure you 
-have both the big endian target ('mips') and the little endian target 
-('mipsel').
-.TP
-\fB\-\-x86\fR
-One oddity of the x86 toolchain is that they may be named 'i386', or 'i486', 
-or 'i586', or 'i686', yet still produce the same exact code.  When dealing 
-with distcc systems that are mixed (some i586 and some i686), you will need 
-symlinks for all these targets.  This option will install those extra targets.
 .SH "REPORTING BUGS"
 Please report bugs via http://bugs.gentoo.org/
 .SH "SEE ALSO"

diff --git a/sys-devel/binutils-config/patches/binutils-config-prefix.patch 
b/sys-devel/binutils-config/patches/binutils-config-prefix.patch
deleted file mode 100644
index b53b171..0000000
--- a/sys-devel/binutils-config/patches/binutils-config-prefix.patch
+++ /dev/null
@@ -1,209 +0,0 @@
-Index: binutils-config/files/binutils-config-3
-===================================================================
---- binutils-config.orig/files/binutils-config-3       2013-07-01 
00:00:01.290790244 +0900
-+++ binutils-config/files/binutils-config-3    2013-07-01 00:27:56.899099185 
+0900
-@@ -7,17 +7,23 @@
- #  config-TARGET:     CURRENT=version for TARGET
- #  TARGET-VER:                has a TARGET and VER variable
- 
-+EPREFIX="@GENTOO_PORTAGE_EPREFIX@"
-+if [[ ${EPREFIX} == "@"GENTOO_PORTAGE_EPREFIX"@" ]] ; then
-+       EPREFIX=""
-+fi
-+
- : ${ROOT:=/}
- [[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
- [[ ${ROOT} != /* ]] && ROOT="${PWD%/}/${ROOT}"
-+EROOT="${ROOT%/}${EPREFIX}/"
- 
--cd /
-+cd "${EPREFIX}"
- 
- trap ":" INT QUIT TSTP
- 
- argv0=${0##*/}
--source /etc/init.d/functions.sh || {
--      echo "${argv0}: Could not source /etc/init.d/functions.sh!" 1>&2
-+source "${EPREFIX}"/etc/init.d/functions.sh || {
-+      echo "${argv0}: Could not source ${EPREFIX}/etc/init.d/functions.sh!" 
1>&2
-       exit 1
- }
- esyslog() { :; }
-@@ -123,14 +129,14 @@
-               # Newer paths: /usr/${HOST}/${TARGET}/...
-               # Older paths: /usr/${TARGET}/...
-               #
--              if [[ -d ${ROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] ; 
then
--                      BINPATH=/usr/${HOST}/${TARGET}/binutils-bin/${VER}
--                      BINPATH_LINKS=/usr/libexec/gcc/${TARGET}
-+              if [[ -d ${EROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] 
; then
-+                      
BINPATH="${EPREFIX}"/usr/${HOST}/${TARGET}/binutils-bin/${VER}
-+                      BINPATH_LINKS="${EPREFIX}"/usr/libexec/gcc/${TARGET}
-               fi
-       fi
-       if [[ -z ${BINPATH} ]] ; then
--              BINPATH=/usr/${TARGET}/binutils-bin/${VER}
--              BINPATH_LINKS=/usr/${TARGET}/bin
-+              BINPATH="${EPREFIX}"/usr/${TARGET}/binutils-bin/${VER}
-+              BINPATH_LINKS="${EPREFIX}"/usr/${TARGET}/bin
-       fi
- }
- 
-@@ -140,16 +146,16 @@
-       setup_env || return 1
- 
-       cd "${ROOT}/${BINPATH}" || exit 1
--      mkdir -p "${ROOT}/${BINPATH_LINKS}" "${ROOT}/usr/bin"
-+      mkdir -p "${ROOT}/${BINPATH_LINKS}" "${EROOT}/usr/bin"
-       for x in * ; do
-               atomic_ln "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}" "${x}"
--              atomic_ln "${BINPATH_LINKS}/${x}" "${ROOT}/usr/bin/" 
"${TARGET}-${x}"
-+              atomic_ln "${BINPATH_LINKS}/${x}" "${EROOT}/usr/bin/" 
"${TARGET}-${x}"
-               for fake in ${FAKE_TARGETS} ; do
-                       [[ -f ${ENV_D}/config-${fake} ]] && continue
--                      atomic_ln "${BINPATH_LINKS}/${x}" "${ROOT}/usr/bin" 
"${fake}-${x}"
-+                      atomic_ln "${BINPATH_LINKS}/${x}" "${EROOT}/usr/bin" 
"${fake}-${x}"
-               done
-               if [[ ${TARGET} == ${HOST} ]] ; then
--                      atomic_ln "${TARGET}-${x}" "${ROOT}/usr/bin" "${x}"
-+                      atomic_ln "${TARGET}-${x}" "${EROOT}/usr/bin" "${x}"
-               fi
-       done
- 
-@@ -159,9 +165,9 @@
-       : ${LIBPATH:=/usr/lib/binutils/${TARGET}/${VER}}
-       cd "${ROOT}/${LIBPATH}" || exit 1
-       if [[ ${TARGET} == ${HOST} ]] ; then
--              dstlib=${ROOT}/usr/${HOST}/lib
-+              dstlib=${EROOT}/usr/${HOST}/lib
-       else
--              dstlib=${ROOT}/usr/${HOST}/${TARGET}/lib
-+              dstlib=${EROOT}/usr/${HOST}/${TARGET}/lib
-       fi
-       # When upgrading, we need to clean up ldscripts and libs
-       mkdir -p "${dstlib}"
-@@ -179,16 +185,16 @@
-       if [[ -d ${ROOT}/${INCPATH} ]] ; then
-               cd "${ROOT}/${INCPATH}" || exit 1
-               if [[ ${HOST} == ${TARGET} ]] ; then
--                      mkdir -p "${ROOT}/usr/include"
-+                      mkdir -p "${EROOT}/usr/include"
-                       for x in * ; do
--                              atomic_ln "${INCPATH}/${x}" 
"${ROOT}/usr/include" "${x}"
-+                              atomic_ln "${INCPATH}/${x}" 
"${EROOT}/usr/include" "${x}"
-                       done
-               else
-                       # Clean out old path -- cannot use '-exec {} +' syntax 
here
--                      find . -type f -exec rm -f 
"${ROOT}/usr/${TARGET}/usr/include/{}" \;
--                      rmdir "${ROOT}/usr/${TARGET}/usr/include" >& /dev/null
--                      rmdir "${ROOT}/usr/${TARGET}/usr" >& /dev/null
--                      rmdir "${ROOT}/usr/${TARGET}" >& /dev/null
-+                      find . -type f -exec rm -f 
"${EROOT}/usr/${TARGET}/usr/include/{}" \;
-+                      rmdir "${EROOT}/usr/${TARGET}/usr/include" >& /dev/null
-+                      rmdir "${EROOT}/usr/${TARGET}/usr" >& /dev/null
-+                      rmdir "${EROOT}/usr/${TARGET}" >& /dev/null
-               fi
-       fi
- 
-@@ -196,20 +202,20 @@
-       # Make sure proper paths get updated
-       #
-       if [[ ${TARGET} == ${HOST} ]] ; then
--              DATAPATH=/usr/share/binutils-data/${TARGET}/${VER}
--              local e="${ROOT}"/etc/env.d/05binutils
-+              DATAPATH="${EPREFIX}"/usr/share/binutils-data/${TARGET}/${VER}
-+              local e="${EROOT}"/etc/env.d/05binutils
-               local ee="${e}.tmp"
-               rm -f "${ee}"
-               [[ -d ${DATAPATH}/man  ]] && echo "MANPATH=${DATAPATH}/man"   
>> "${ee}"
-               [[ -d ${DATAPATH}/info ]] && echo "INFOPATH=${DATAPATH}/info" 
>> "${ee}"
-               # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
--              if [[ -d ${ROOT}/etc/ld.so.conf.d ]] ; then
--                      local l="${ROOT}"/etc/ld.so.conf.d/05binutils.conf
-+              if [[ -d ${EROOT}/etc/ld.so.conf.d ]] ; then
-+                      local l="${EROOT}"/etc/ld.so.conf.d/05binutils.conf
-                       local ll="${l}.tmp"
-                       echo "/usr/${TARGET}/lib" > "${ll}"
-                       mv_if_diff "${ll}" "${l}"
-               else
--                      echo "LDPATH=/usr/${TARGET}/lib" >> "${ee}"
-+                      echo "LDPATH=${EPREFIX}/usr/${TARGET}/lib" >> "${ee}"
-               fi
-               mv_if_diff "${ee}" "${e}"
-       fi
-@@ -254,7 +260,7 @@
-               die "no profiles exist for '${TARGET}'"
-       fi
- 
--      rm -f "${ENV_D}"/config-${TARGET} 
"${ROOT}"/etc/ld.so.conf.d/05binutils.conf
-+      rm -f "${ENV_D}"/config-${TARGET} 
"${EROOT}"/etc/ld.so.conf.d/05binutils.conf
- 
-       # XXX: we still leave behind FAKE_TARGETS in /usr/bin ...
-       local x
-@@ -264,28 +270,28 @@
-               nm objcopy objdump ranlib readelf size strings strip
-       do
-               x=(
--                      "${ROOT}"/usr/bin/${TARGET}-${x}
--                      "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
--                      "${ROOT}"/usr/libexec/gcc/${TARGET}/${x}
-+                      "${EROOT}"/usr/bin/${TARGET}-${x}
-+                      "${EROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
-+                      "${EROOT}"/usr/libexec/gcc/${TARGET}/${x}
-               )
-               rm -f "${x[@]}"
-       done
-       for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
--              rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
-+              rm -f "${EROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
-       done
-       for x in bfd iberty opcodes ; do
--              rm -f 
"${ROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
-+              rm -f 
"${EROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
-       done
-       # Delete broken symlinks
--      local destdir="${ROOT}/usr/${HOST}/${TARGET}"
-+      local destdir="${EROOT}/usr/${HOST}/${TARGET}"
-       rm -f "${destdir}"/lib/ldscripts
-       find -L "${destdir}"/lib -type l -exec rm {} +
-       rmdir \
-               "${destdir}"/{bin,include,lib,usr} \
-               "${destdir}" \
--              "${ROOT}"/var/db/pkg/cross-${TARGET} \
--              "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin \
--              "${ROOT}"/usr/libexec/gcc/${TARGET} \
-+              "${EROOT}"/var/db/pkg/cross-${TARGET} \
-+              "${EROOT}"/usr/{${HOST}/,}${TARGET}/bin \
-+              "${EROOT}"/usr/libexec/gcc/${TARGET} \
-               2>/dev/null
- 
-       rm -f "${ENV_D}"/${TARGET}-*
-@@ -384,7 +390,7 @@
-       : ${HOST:=${CHOST:-$(portageq envvar CHOST)}}
- }
- 
--ENV_D="${ROOT}etc/env.d/binutils"
-+ENV_D="${EROOT}etc/env.d/binutils"
- 
- DEBUG="no"
- NEED_ACTION="yes"
-Index: binutils-config/binutils-config-3-r3.ebuild
-===================================================================
---- binutils-config.orig/binutils-config-3-r3.ebuild   2013-06-30 
23:30:54.858130147 +0900
-+++ binutils-config/binutils-config-3-r3.ebuild        2013-07-01 
00:20:17.812822647 +0900
-@@ -13,7 +13,14 @@
- 
- RDEPEND="userland_GNU? ( !<sys-apps/findutils-4.2 )"
- 
-+inherit prefix
-+
-+src_unpack() {
-+      cp "${FILESDIR}"/${P} ${PN} || die
-+      eprefixify ${PN} || die
-+}
-+
- src_install() {
--      newbin "${FILESDIR}"/${PN}-${PV} ${PN} || die
-+      dobin ${PN} || die
-       doman "${FILESDIR}"/${PN}.8
- }

diff --git a/sys-devel/binutils-config/patches/series 
b/sys-devel/binutils-config/patches/series
deleted file mode 100644
index f304ad7..0000000
--- a/sys-devel/binutils-config/patches/series
+++ /dev/null
@@ -1 +0,0 @@
-binutils-config-prefix.patch

Reply via email to